# The Cut Audio functionality
====

## Overview

This component of the multimedia_project is called cut_audio.

It uses ffmpeg to cut audio files in a convenient way.

In the past it was an external project, but it was eventually
merged into the multimedia_project.

Version 1.0.3 added 'open' functionality so that we can edit the
.rb file in question directly. Also, providing an end position
is now optional. If omitted, we will simply default to the max
length of the file in question.

Version 1.0.6 added 'chop_off' syntax - we can now chop off from
the end of the audio file.

## Usage of the Cut Audio Project

After installation, you can use the executable

    cut_audio

So, find yourself some audio file to work with, let's call it
**foo.mp3** for the purpose of this file.

Then you can do the following, by providing the path to this
file in question:

    cut_audio foo.mp3

This will put you into the interactive mode. You can also use it
in a non-interactive way, from within other ruby files of course.

Now, in the interactive variant, you can issue the help command
if you want to:

    help

This will give an overview of how to use the interactive part
of CutAudio.

You can then **cut** on this .mp3 file.

In order to do so, you have to first define **start** and
**end** positions. These define the interval between where
the cutting will be done.

For instance, to **define a start position at 3.2 seconds**,
you can issue this:

    s3.2

or

    s 3.2

The "s" here is short for "start".

Then, you must define an end point, let's say at position 8.5:

    e8.5

or

    e 8.5

Obviously, the **e** is short for "end".

Since September 2014, the leading 's' and the leading 'e' became
optional - so you can simply input a start number, then an end
number. This of course requires of you to set sane start and
end values - "1,5" is ok, "4,3" is not logical.

You can continue defining more start and end points until you are
finished. Then, when you have defined these start and end points,
you can cut the segment.

Cutting means that we will actually cut out the part that we wish
to keep.

So in the above context, we wish to keep position starting from
3.2 up until position 8.5.

Now you are ready to do the cutting, so issue:

    cut

We call these timespans ***setpoints***.

You can of course define several **setpoints** - the command "cut" will
take care of producing several individual audio files from this, using
ffmpeg.

You can merge different audio files together, in particular these 
different setpoints (if you have more than one setpoint of course),
by issuing:

    merge

You can delete the individual files again if you want to, by 
issuing:

    delete

To quit, simply do "q" or "quit" or just hit Control-C.

cut_audio is supposed to cut audio files using ffmpeg. In other words,
you currently need to have ffmpeg available - the bin/ffmpeg file 
from the commandline. (We could in principle use another audio-layer,
but ffmpeg is very good - if you know of something else that should
be supported, let me know.)

The name of the cut_audio script is, unsurprisingly, called:

    bin/cut_audio

It will reside in the multimedia_paradise directory.

That means that on a default ruby install, on a *nix system, it
should be available at:
    
    /usr/bin/cut_audio

And provided that /usr/bin is part of your $PATH variable, it
can then be simply invoked via:

    cut_audio
    cut_audio FILENAME_HERE
    cut_audio test.mp3

This will open an interactive menu. Type "help" to get the 
help output. You need to define start and end values for 
where to cut that file manually.
    
Start has a leading "s" and end has a leading "e".
    
For instance:
    
    s5
    e8

Means: start at 5 seconds, end at 8 seconds.

Milliseconds are also possible:

    s5.33
    e8.11
    
Means to start cutting at 5.33 second mark, and end 
at 8.11 second mark.

The original file will not be modified - instead, a new
file will be created.

In the interactive menu, you can also issue "mpl" or "play"
or "mplayer" to play the audio file. This may help you to
decide where to start cutting.

Also note that you can define multiple setpoints. So you
can type s5, s11, s99 and also e8, e88, e123. This would
create 3 audio files. These files can also be merged 
if you want to, by issuing "merge".

Thank you and have fun.