# =========================================================================== #
# Gemspec for Project MultimediaParadise.
# =========================================================================== #
require 'multimedia_paradise/version/version.rb'
require 'roebe/toplevel_methods/misc.rb'

Gem::Specification.new { |s|

  s.name    = 'multimedia_paradise'
  s.version = MultimediaParadise::VERSION
  s.date    = Time.now.strftime('%Y-%m-%d')

  DESCRIPTION = <<-EOF

This project is a collection of video- and audio-related scripts -
multimedia-related actions, such as cutting audio files,
merging video files, listening to online-stream radio and so
forth.

Most of the functionality depends on external projects such as
ffmpeg, mpv or sox, so consider installing these projects if you
have not already done so. (They should work on windows fine
as well.)

For more information about this project, please consider having
a look at the official documentation (at
https://www.rubydoc.info/gems/multimedia_paradise/
or just click on the link called Documentation, at the
homepage of this gem at https://rubygems.org/gems/multimedia_paradise/ 
respectively at https://www.rubydoc.info/gems/multimedia_paradise/ ).

  EOF

  s.summary     = DESCRIPTION
  s.description = DESCRIPTION
  
  s.authors     = ['Robert A. Heiler']
  s.email       = Roebe.email?
  s.files       = Dir['**/*']
  s.license     = 'GPL-2.0'
  s.executables = Dir['bin/*'].map { |f| File.basename(f) }
  s.homepage    = 'https://rubygems.org/gems/multimedia_paradise'

  # ========================================================================= #
  # Show this when a user installs the MultimediaParadise project.
  # ========================================================================= #
  s.post_install_message = <<-EOF                                                                                                                                                             

  This gem will install some executable scripts in its bin/ directory.

  Two worth mentioning are the following:
    
      cut_audio      # Allows you to cut audio files, in particular .mp3 files

  The other file that may be useful is:

      extract_audio  # Allows you to extract the audio from e. g. a .mkv or .mp4 file

  Note that both cut_audio and extract_audio make use of ffmpeg right now.        

  EOF

  s.required_ruby_version     = '>= '+Roebe.third_most_stable_version_of_ruby
  s.required_rubygems_version = '>= '+Gem::VERSION
  s.rubygems_version          = '>= '+Gem::VERSION

  # ========================================================================= #
  # Dependencies for the project:
  # ========================================================================= #
  s.add_dependency 'colours'
  s.add_dependency 'cliner'
  s.add_dependency 'hours_to_seconds'
  s.add_dependency 'opn'
  s.add_dependency 'save_file'

}